Bug 429852 - package-cleanup is confused by Requires(pre) -- Eg. rm xorg-x11-filesystem
package-cleanup is confused by Requires(pre) -- Eg. rm xorg-x11-filesystem
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: yum-utils (Show other bugs)
10
All Linux
low Severity low
: ---
: ---
Assigned To: Seth Vidal
Fedora Extras Quality Assurance
: Reopened, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-23 09:21 EST by petrosyan
Modified: 2009-12-18 01:02 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 01:02:53 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description petrosyan 2008-01-23 09:21:15 EST
Description of problem:
If I type 'rpm -e xorg-x11-filesystem' the package gets uninstalled without any
warnings. However running 'package-cleanup --problems' shows the following
missing dependencies:
Missing dependencies:
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-font-utils requires xorg-x11-filesystem >= 0.99.2-3

Version-Release number of selected component (if applicable):
xorg-x11-filesystem-7.1-2.fc6

How reproducible:
Always

Steps to Reproduce:
1. rpm -e xorg-x11-filesystem
2. package-cleanup --problems
  
Actual results:
Missing dependencies:
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-font-utils requires xorg-x11-filesystem >= 0.99.2-3

Expected results:
rpm should complain about missing dependencies and not uninstall xorg-x11-filesystem
Comment 1 Matěj Cepl 2008-01-24 12:04:41 EST
Well, yes:

[root@hubmaier ~]# rpm -e xorg-x11-filesystem
[root@hubmaier ~]# package-cleanup --problems
Setting up yum
Excluding Packages in global exclude list
Finished
Excluding Packages in global exclude list
Finished
Reading local RPM database
Processing all local requires
Missing dependencies:
Package libXmu-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package libXp-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-xdm requires xorg-x11-filesystem >= 0.99.2-3
Package libXcursor-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-font-utils requires xorg-x11-filesystem >= 0.99.2-3
Package libXcomposite-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXfixes-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXdmcp-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXrandr-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXext-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libX11-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXScrnSaver-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-proto-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXi-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXau-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXrender-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package libXdamage-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXpm-devel requires xorg-x11-filesystem >= 0.99.2-3
Package alsa-lib-devel requires alsa-lib = 1.0.15-1.hg20071113.fc9
Package libXtst-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libSM-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXft-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-apps requires xorg-x11-filesystem >= 0.99.2-3
Package libXt-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libICE-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXinerama-devel requires xorg-x11-filesystem >= 0.99.2-3
[root@hubmaier ~]# 
Comment 2 Adam Jackson 2008-02-11 15:30:04 EST
It's worse than that though.

atropine:~% rpm -q --whatrequires xorg-x11-filesystem
no package requires xorg-x11-filesystem
atropine:~% rpm -q --requires libX11 | grep filesystem
xorg-x11-filesystem >= 0.99.2-3

This happens even after rpm --rebuilddb, so I call rpm bug on this one.  And a
nasty one at that.  Reassigning and putting on the F9 blocker list.  Relevant NEVRs:

atropine:~% rpm -q xorg-x11-filesystem libX11 rpm
xorg-x11-filesystem-7.1-2.fc6
libX11-1.1.3-4.fc8
rpm-4.4.2.2-13.fc9
Comment 3 Paul Nasrat 2008-02-11 18:14:03 EST
rpm --qf '[%{requirename} %{requireversion} %{requireflags}\n]' -q libX11 

It's actually a Requires(pre) not a Requires.
Comment 4 Paul Nasrat 2008-02-11 18:31:26 EST
If you see http://people.redhat.com/pnasrat/requirer.spec and replace the
Requires: with xorg-x11-filesystem you'll see a normal Requires: works, but
Requires(pre): allows an erase.

rpmdsdebug will probably be useful.
Comment 5 Bill Nottingham 2008-02-12 15:31:04 EST
Hm, that may be expected behavior - if it's only a requires for Pre:, then it's
not needed for runtime. It will get pulled back in by the Requires(pre) of the
next libX11 update.
Comment 6 Adam Jackson 2008-02-13 13:45:33 EST
I'm seeing this in RHEL5 too, for whatever that's worth.  So it may just be that
package-cleanup is being a bit hysterical.
Comment 7 Jeff Johnson 2008-02-13 22:17:21 EST
The "pulled back in" will occur iff not presently installed, which is typically
what happens in practice. Certainly "pulled back in" is exactly what is necessary
for topological sort prerequisites (I'm not referring to PreReq: or Requires(pre):)
to be satisified mathematically.
Comment 8 Adam Jackson 2008-02-18 10:11:07 EST
Right, I withdraw my hysteria.  Blaming yum-utils, package-cleanup should
probably not whinge about this.
Comment 9 Seth Vidal 2008-02-18 10:31:00 EST
out of curiosity does:
rpm -Va --nofiles --nomd5

also whinge about the unsatisfied deps?
Comment 10 Seth Vidal 2008-03-13 10:57:13 EDT
Ajax? ping?
Comment 11 Seth Vidal 2008-05-30 11:14:38 EDT
closing this insufficient-info
Comment 12 petrosyan 2008-05-31 00:05:58 EDT
this bug is still present in Fedora 9.
# rpm -e xorg-x11-filesystem
# package-cleanup --problems
Setting up yum
Reading local RPM database
Processing all local requires
Missing dependencies:
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-font-utils requires xorg-x11-filesystem >= 0.99.2-3
---------------------------------------------------------------------
# rpm -V --nofiles --nomd5 xorg-x11-font-utils
Unsatisfied dependencies for xorg-x11-font-utils-7.2-4.fc9.x86_64:
xorg-x11-filesystem >= 0.99.2-3
Comment 13 Panu Matilainen 2008-06-02 02:08:31 EDT
Two separate bugs here, one is in package-cleanup which uses it's own algorithm
for the dep checking and the other one is rpm's own dependency verification
disagreeing with the rest of rpm (see bug 223642).
Comment 14 Jan Hutař 2008-08-07 07:55:30 EDT
Providing info requested in comment #9:

# rpm -e xorg-x11-filesystem
# package-cleanup --problems
Setting up yum
Reading local RPM database
Processing all local requires
Missing dependencies:
Package libX11 requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-xdm requires xorg-x11-filesystem >= 0.99.2-3
Package libX11-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXpm-devel requires xorg-x11-filesystem >= 0.99.2-3
Package libXdmcp-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-font-utils requires xorg-x11-filesystem >= 0.99.2-3
Package libXau-devel requires xorg-x11-filesystem >= 0.99.2-3
Package xorg-x11-proto-devel requires xorg-x11-filesystem >= 0.99.2-3
# rpm -Va --nofiles --nomd5
Unsatisfied dependencies for libXdmcp-devel-1.0.2-4.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for xorg-x11-font-utils-7.2-2.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for libX11-devel-1.1.3-4.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for xorg-x11-xdm-1.1.6-2.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for libX11-1.1.3-4.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for libXau-devel-1.0.3-3.fc8.i386: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for xorg-x11-proto-devel-7.3-3.fc8.noarch: xorg-x11-filesystem >= 0.99.2-3
Unsatisfied dependencies for libXpm-devel-3.5.7-1.fc8.i386: xorg-x11-filesystem >= 0.99.2-3



yum-3.2.7-1.fc8
rpm-4.4.2.2-3.fc8
yum-utils-1.1.8-1.fc8
Comment 15 Bug Zapper 2008-11-25 21:05:27 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 16 Bug Zapper 2009-11-18 07:25:10 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 17 Bug Zapper 2009-12-18 01:02:53 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.